unit TabClientFra;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, StdCtrls;

type
  TfraTabClient = class(TFrame)
    btnShowTabModal: TButton;
    procedure btnShowTabModalClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    function GetModalParent: TWinControl;
    constructor Create(AOwner: TComponent); override;
  end;

implementation

uses
  Math, TestTabModalFra;

{$R *.dfm}

{ TfraTabClient }

constructor TfraTabClient.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  btnShowTabModal.Left := Max(0, Random(Width - btnShowTabModal.Width));
end;

procedure TfraTabClient.btnShowTabModalClick(Sender: TObject);
var
  Frame: TfraTestTabModal;
begin
  Frame := TfraTestTabModal.Create(nil);
  try
    Frame.ShowTabModal(Self); // blocks execution until the tab-modal frame is closed
    ShowMessage('Returned');
  finally
    Frame.Free;
  end;
end;

function TfraTabClient.GetModalParent: TWinControl;
begin
  // Could be used to put the tab-modal frames on a semi-transparent panel
  Result := Self;
end;

end.
